From 3e78b7f1b0c5cf4459a72996a0c53780fa39b121 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jun 08 2015 05:01:21 +0000
Subject: [PATCH 103/254] Merge branch 'feature/mass-populate' into develop


---

diff --git a/hubs/hinting.py b/hubs/hinting.py
index 47e7d14..9f049f3 100644
--- a/hubs/hinting.py
+++ b/hubs/hinting.py
@@ -10,7 +10,8 @@ log = logging.getLogger('hubs.hinting')
 def hint(topics=None, categories=None, usernames=None):
     topics = topics or []
     categories = categories or []
-    usernames = usernames or lambda x: []
+    default_usernames = lambda x: []
+    usernames = usernames or default_usernames
 
     @decorator.decorator
     def wrapper(fn, *args, **kwargs):
diff --git a/hubs/widgets/about.py b/hubs/widgets/about.py
index 55693c9..b0df6cc 100644
--- a/hubs/widgets/about.py
+++ b/hubs/widgets/about.py
@@ -1,3 +1,4 @@
+from hubs.hinting import hint, prefixed as _
 from hubs.widgets.chrome import panel
 from hubs.widgets.base import argument
 
diff --git a/hubs/widgets/avatar.py b/hubs/widgets/avatar.py
index bcda21d..bf49bf6 100644
--- a/hubs/widgets/avatar.py
+++ b/hubs/widgets/avatar.py
@@ -1,3 +1,4 @@
+from hubs.hinting import hint, prefixed as _
 from hubs.widgets.base import argument
 from hubs.utils import username2avatar
 
diff --git a/hubs/widgets/fedmsgstats.py b/hubs/widgets/fedmsgstats.py
index 0c22872..5f985af 100644
--- a/hubs/widgets/fedmsgstats.py
+++ b/hubs/widgets/fedmsgstats.py
@@ -1,3 +1,4 @@
+from hubs.hinting import hint
 from hubs.widgets.chrome import panel
 
 import jinja2
diff --git a/populate-all-users.py b/populate-all-users.py
new file mode 100755
index 0000000..401a20e
--- /dev/null
+++ b/populate-all-users.py
@@ -0,0 +1,38 @@
+#!/usr/bin/env python
+""" Populate the hubs db with lots of data from FAS. """
+
+import getpass
+import socket
+import string
+
+import hubs.models
+
+import fedora.client.fas2
+import fedmsg.config
+fedmsg_config = fedmsg.config.load_config()
+
+fasclient = fedora.client.fas2.AccountSystem(
+    username=raw_input('Your FAS username: '),
+    password=getpass.getpass(),
+)
+timeout = socket.getdefaulttimeout()
+socket.setdefaulttimeout(None)
+
+for letter in reversed(sorted(list(set(string.letters.lower())))):
+    session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'], True, True)
+    print "Querying FAS for the %r users.. hang on." % letter
+    request = fasclient.send_request('/user/list',
+                                    req_params={'search': '%s*' % letter},
+                                    auth=True,
+                                    timeout=500)
+    users = request['people']
+
+    for user in users:
+        username = user['username']
+        fullname = user['human_name']
+        openid = '%s.id.fedoraproject.org' % username
+        print "Creating account for %r" % openid
+        hubs.models.User.get_or_create(
+            session, openid=openid, fullname=fullname)
+
+    session.commit()

